;
;
;

#include    <P12F683.inc>
 LIST P=PIC12F683
 

    errorlevel  -302                ; suppress banking messages
    __CONFIG _CP_OFF & _CPD_OFF & _BOD_OFF & _PWRTE_ON & _WDT_OFF & _INTRC_OSC_NOCLKOUT & _MCLRE_OFF & _FCMEN_OFF & _IESO_OFF

;**********************************************************************
; Macros
;**********************************************************************
; bank select macros
#define setbank0    bcf STATUS,RP0  ; select bank 0
#define setbank1    bsf STATUS,RP0  ; select bank 

mem = 21
var macro name
name equ  mem
mem = mem + 1
   if (mem > 0xef)
      error 'Too much var space used'
   endm 

mem2 = 0x7F
var_all_bank macro name
name equ  mem2
mem2 = mem2 - 1
   if (mem >= mem2)
      error 'Too much var space used'
   endm


#ifdef __12F683
PORTA       EQU GPIO
TRISA       EQU TRISIO
NOT_RAPU    EQU NOT_GPPU
#endif
 
;**********************************************************************
    ORG     0x000           ; processor reset vector
;**********************************************************************
    goto        main            ; go to beginning of program
    
;**********************************************************************
    ORG     0x004           ; interrupt vector location
;**********************************************************************
    var_all_bank w_temp          ; variable used for context saving
    var_all_bank status_temp     ; variable used for context saving
    var_all_bank intcon_save     ; variable used for context saving
    var_all_bank pclath_temp

#ifdef __12F683
    movwf       w_temp          ; copy W to TEMP register
    swapf       STATUS,w        ; Swap status to be saved into W
    clrf        STATUS          ; Bank 0
    movwf       status_temp     ; save off contents of PCLATH register
#endif

;--------------------------------------------------------------------------------------
exit_tx
;--------------------------------------------------------------------------------------

;   clear timer0 interupt
    bcf         INTCON,T0IF

; restore state, return form interupt

exit_int
#ifdef __12F683
    swapf       status_temp,w
    movwf       STATUS
    swapf       w_temp,f
    swapf       w_temp,w
#endif
    retfie                  ; return from interrupt
    
   ;

;**********************************************************************
delay
;**********************************************************************
    var         count1
    var         count2
    var         count3

    movlw   0xF7
    movwf   count2

delay1

    incfsz      count1,f
    goto        delay1

    incfsz      count2,f
    goto        delay1

;    incfsz      count3,f
;    goto        delay1

   return   
   
; M A I N
;
;**********************************************************************
main
;**********************************************************************

    movlw   0x07
    movwf   CMCON0      ;turn off comparator

    setbank1

; set up TMR0 & pullups
;             +---------- disable pullups (1)
;             |+--------- interrupt edge select (don't care)
;             ||+-------- TMR0 source = internal clock (0)
;             |||+------- TMR0 source edge select (don't care)
;             ||||+------ assign prescaler to TMR0 (0)
;             |||||+++--- prescaler set to 8X (010)
;             |||||||| 
    movlw   b'10000010'
    movwf   OPTION_REG


    movlw   b'01110000'     ;switch to 8 MHz clock
    iorwf   OSCCON,f

    clrf    ANSEL           ;set pins to digital

    movlw   b'00000000'
    movwf   TRISA

    setbank0

;   enable timer0 interupt
;    bsf     INTCON,T0IE
;    bsf     INTCON,GIE


Loop
	movlw   b'00100010'  
    movwf   PORTA
    call    delay
    
;    movlw   b'00000111'  
;    movwf   PORTA
;    call    delay
    
    movlw   b'00000001'  
    movwf   PORTA
    call    delay
    
;    movlw   b'00010101' 
;    movwf   PORTA
;    call    delay

    movlw   b'00010000'   
    movwf   PORTA
    call    delay
    
    movlw   b'00010110'  
    movwf   PORTA
    call    delay

	goto	Loop

    end
