;**********************************************************************
;   Copyright (C) 2012 Dwayne Forsyth
;                                 
;   This program is free software; you can redistribute it and/or
;   modify it under the terms of the GNU General Public License
;   as published by the Free Software Foundation; either version 2
;   of the License, or (at your option) any later version.
; 
;   This program is distributed in the hope that it will be useful,
;   but WITHOUT ANY WARRANTY; without even the implied warranty of
;   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;   GNU General Public License for more details.
;
;   You should have received a copy of the GNU General Public License
;   along with this program; if not, write to the
; 
;      Free Software Foundation, Inc.
;      51 Franklin Street, Fifth Floor
;      Boston, MA  02110-1301, USA.
;
;**********************************************************************

;**********************************************************************
table_type_36
;**********************************************************************
; in0 

   clrf         in0
   clrf         in1
   clrf         in2
   clrf         in3
   clrf         in4
   clrf         in5
   clrf         in6
   clrf         in7
   clrf         in8
   clrf         in9

   movlw        0x03
   movwf        speed
   call         display_1bit

   call  get_next_pattern_entry
   movwf        char_in


;  save fsr1
   movfw        FSR1H     
   movwf        save_fsr1h 
   movfw        FSR1L
   movwf        save_fsr1l

   movf         char_in,f         ; test for zero
   btfsc        STATUS,Z
   goto         t4_end_string

   movlw        0x20              ; color code?
   subwf        char_in,w
   btfsc        STATUS,C
   goto         t4_skipt3

   movf         char_in,w         ; get color, then pull next entry
   movwf        char_color
   goto         table_type_36

t4_skipt3
   movfw        char_in
   call         display_char
   goto         t4_end_char

t4_end_string

t4_end_char
;   movfw        pspeed
    movlw        0xff
    call         display_1bit

   return

;**********************************************************************
display_char 
;**********************************************************************
   var  dchar
   var  t4_count


   movwf        dchar             ; input in "w", save in dchar  

   movf         dchar,f         ; test for zero
   btfss        STATUS,Z
   goto         dchar_less

   movlw        0x7c              ; if end of pattern show char "#"
   movwf        dchar
   goto         dchar_printable

dchar_less
   movlw        0x20              ; is the char less them 0x20? color code?
   subwf        dchar,w
   btfsc        STATUS,C
   goto         dchar_tcont

   movf         dchar,w         ; get color, then switch to box char from printing (0x7b)
   movwf        char_color
   movlw        0x7b
   movwf        dchar
   goto         dchar_printable

dchar_tcont
   movlw        0x7b              ; is the char greater them 0x7b?
   subwf        dchar,w
   btfss        STATUS,C
   goto         dchar_printable

   movlw        0x7d
   movwf        dchar  

dchar_printable
; char_in = char_in - 0x20
   movlw        0x20              
   subwf        char_in,f        

; offset = chartabel
   movlw        LOW chartable     
   movwf        offset_low 
   movlw        HIGH chartable
   movwf        offset_hi

; offset = offset + char_in <<1
   movf         char_in,w
   bcf          STATUS, C         ; clear carry flag just in case
   rlf          char_in,w           
   addwf        offset_low, f
   btfsc        STATUS,C          ; check carry flag
   incf         offset_hi,f   

; char_in << 2 ; if carry offset_hi++         
   bcf          STATUS, C         ; clear carry flag just in case
   rlf          char_in, f
   rlf          char_in, f
   btfsc        STATUS,C          ; check carry flag
   incf         offset_hi,f 

; offset = offset + char_in
   movf         char_in,w           ; offset = offset + char_in
   addwf        offset_low, f
   btfsc        STATUS,C          ; check carry flag
   incf         offset_hi,f     

;  FSR1 = offset
   movfw        offset_hi
   movwf        FSR1H
   movfw        offset_low
   movwf        FSR1L


   moviw       FSR1++    ; char table, 1st byte is char size
   movlw       0x05      ; override the size to 5.
   movwf       char_words

t4_looper
   moviw        FSR1++    ; char table
   movwf        tentry

; -------------------
    call shift_left

    movf  tentry, w
    movwf in8

    movf  tentry, w
    movwf in9

   btfss        char_color,0     ; color adjust
   clrf         in8

   btfss        char_color,2
   clrf         in9

   btfsc        char_color,1
   comf         in8,f

   btfsc        char_color,3
   comf         in9,f
   
; ------------------

   decfsz       char_words,f
   goto         t4_looper

;  restore fsr1
   movfw        save_fsr1h    
   movwf        FSR1H  
   movfw        save_fsr1l
   movwf        FSR1L


   return

