;-------------------------------------------------------------------------------
display_cycle0 ; A0
;-------------------------------------------------------------------------------

    bsf                  Ax_dir, 1 ;   A1 Led Blue
    bsf                  Ax_dir, 2 ;   A2 Led Blue
    bsf                  Cx_dir, 0 ;   C0 Led Blue
    bsf                  Cx_dir, 1 ;   C1 Led Blue 
    LedOutInd A0_C2_reg, Cx_dir, 2 ;   C2 Led Red
    LedOutInd A0_C3_reg, Cx_dir, 3 ;   C3 Led Red
    LedOutInd A0_C4_reg, Cx_dir, 4 ;   C4 Led Red
    LedOutInd A0_C5_reg, Cx_dir, 5 ;   C5 Led Red

    banksel TRISA
    movf    Ax_dir,w      ;set portA direction
    movwf   TRISA
    movf    Cx_dir,w      ;set portA direction
    movwf   TRISC

    banksel PORTA
    movlw   b'00000001'
    movwf   PORTA
    movlw   b'00000000'
    movwf   PORTC

    decfsz  fcount,f
    goto    display_cycle0

    goto return_display_cycle

;-------------------------------------------------------------------------------
display_cycle1 ; A0
;-------------------------------------------------------------------------------

    LedOutInd A0_A1_reg, Ax_dir, 1 ;   A1 Led Blue
    LedOutInd A0_A2_reg, Ax_dir, 2 ;   A2 Led Blue
    LedOutInd A0_C0_reg, Cx_dir, 0 ;   C0 Led Blue
    LedOutInd A0_C1_reg, Cx_dir, 1 ;   C1 Led Blue 
    bsf                  Cx_dir, 2 ;   C2 Led Red
    bsf                  Cx_dir, 3 ;   C3 Led Red
    bsf                  Cx_dir, 4 ;   C4 Led Red
    bsf                  Cx_dir, 5 ;   C5 Led Red

    banksel TRISA
    movf    Ax_dir,w      ;set portA direction
    movwf   TRISA
    movf    Cx_dir,w      ;set portA direction
    movwf   TRISC

    banksel PORTA
    movlw   b'00000001'
    movwf   PORTA
    movlw   b'00000000'
    movwf   PORTC

    decfsz  fcount,f
    goto    display_cycle1

    goto return_display_cycle

;-------------------------------------------------------------------------------
display_cycle2 ; A1
;-------------------------------------------------------------------------------
;
    LedOutInd A1_A0_reg, Ax_dir, 0 ;   A0 Led Red
    LedOutInd A1_A2_reg, Ax_dir, 2 ;   A2 Led Red
    LedOutInd A1_C0_reg, Cx_dir, 0 ;   C0 Led Red
    LedOutInd A1_C1_reg, Cx_dir, 1 ;   C1 Led Red
    bsf                  Cx_dir, 2 ;   C2 No led
    LedOutInd A1_C3_reg, Cx_dir, 3 ;   C3 Led Red
    LedOutInd A1_C4_reg, Cx_dir, 4 ;   C4 Led Red
    LedOutInd A1_C5_reg, Cx_dir, 5 ;   C5 Led Red

    banksel TRISA
    movf    Ax_dir,w      ;set portA direction
    movwf   TRISA
    movf    Cx_dir,w      ;set portA direction
    movwf   TRISC

    banksel PORTA
    movlw   b'00000010'
    movwf   PORTA
    movlw   b'00000000'
    movwf   PORTC

    decfsz  fcount,f
    goto    display_cycle2 

    goto return_display_cycle

;-------------------------------------------------------------------------------
display_cycle3 ; A2
;-------------------------------------------------------------------------------
    LedOutInd A2_A0_reg, Ax_dir, 0 ;   A0 Led 11G
    LedOutInd A2_A1_reg, Ax_dir, 1 ;   A1 Led 1G
    LedOutInd A2_C0_reg, Cx_dir, 0 ;   C0 Led 3R
    LedOutInd A2_C1_reg, Cx_dir, 1 ;   C1 Led 4R
    LedOutInd A2_C2_reg, Cx_dir, 2 ;   C2 Led 15R
    LedOutInd A2_C3_reg, Cx_dir, 3 ;   C3 Led 15R
    LedOutInd A2_C4_reg, Cx_dir, 4 ;   C4 Led 16R
    LedOutInd A2_C5_reg, Cx_dir, 5 ;   C5 Led 16R

    banksel TRISA
    movf    Ax_dir,w      ;set portA direction
    movwf   TRISA
    movf    Cx_dir,w      ;set portA direction
    movwf   TRISC

    banksel PORTA
    movlw   b'00000100'
    movwf   PORTA
    movlw   b'00000000'
    movwf   PORTC

    decfsz  fcount,f
    goto    display_cycle3

    goto return_display_cycle

;-------------------------------------------------------------------------------
display_cycle4 ; C0
;-------------------------------------------------------------------------------
;
    LedOutInd C0_A0_reg, Ax_dir, 0 ;   A0 Led 10G
    LedOutInd C0_A1_reg, Ax_dir, 1 ;   A1 Led 2G
    LedOutInd C0_A2_reg, Ax_dir, 2 ;   A2 Led 3G
    bsf                  Cx_dir, 1 ;   C1 Led 5G
    bsf                  Cx_dir, 2 ;   C2 Led 6R
    bsf                  Cx_dir, 3 ;   C3 Led 6R
    bsf                  Cx_dir, 4 ;   C4 Led 7R
    bsf                  Cx_dir, 5 ;   C5 Led 7R

    banksel TRISA
    movf    Ax_dir,w      ;set portA direction
    movwf   TRISA
    movf    Cx_dir,w      ;set portA direction
    movwf   TRISC

    banksel PORTA
    movlw   b'00000000'
    movwf   PORTA
    movlw   b'00000001'
    movwf   PORTC

    decfsz  fcount,f
    goto    display_cycle4

    goto return_display_cycle

;-------------------------------------------------------------------------------
display_cycle5 ; C0
;-------------------------------------------------------------------------------
;
    bsf                  Ax_dir, 0 ;   A0 Led 10G
    bsf                  Ax_dir, 1 ;   A1 Led 2G
    bsf                  Ax_dir, 2 ;   A2 Led 3G
    LedOutInd C0_C1_reg, Cx_dir, 1 ;   C1 Led 5G
    LedOutInd C0_C2_reg, Cx_dir, 2 ;   C2 Led 6R
    LedOutInd C0_C3_reg, Cx_dir, 3 ;   C3 Led 6R
    LedOutInd C0_C4_reg, Cx_dir, 4 ;   C4 Led 7R
    LedOutInd C0_C5_reg, Cx_dir, 5 ;   C5 Led 7R

    banksel TRISA
    movf    Ax_dir,w      ;set portA direction
    movwf   TRISA
    movf    Cx_dir,w      ;set portA direction
    movwf   TRISC

    banksel PORTA
    movlw   b'00000000'
    movwf   PORTA
    movlw   b'00000001'
    movwf   PORTC

    decfsz  fcount,f
    goto    display_cycle5

    goto return_display_cycle

;-------------------------------------------------------------------------------
display_cycle6 ; C1
;-------------------------------------------------------------------------------
;
    bsf                  Ax_dir, 0 ;   A0 Led 9G
    bsf                  Ax_dir, 1 ;   A1 Led 14G
    bsf                  Ax_dir, 2 ;   A2 Led 4G
    bsf                  Cx_dir, 0 ;   C0 Led 5G
    LedOutInd C1_C2_reg, Cx_dir, 2 ;   C2 no Led
    LedOutInd C1_C3_reg, Cx_dir, 3 ;   C3 no Led
    LedOutInd C1_C4_reg, Cx_dir, 4 ;   C4 Led 8R
    LedOutInd C1_C5_reg, Cx_dir, 5 ;   C5 Led 8R

    banksel TRISA
    movf    Ax_dir,w      ;set portA direction
    movwf   TRISA
    movf    Cx_dir,w      ;set portA direction
    movwf   TRISC

    banksel PORTA
    movlw   b'00000000'
    movwf   PORTA
    movlw   b'00000010'
    movwf   PORTC

    decfsz  fcount,f
    goto    display_cycle6

    goto return_display_cycle

;-------------------------------------------------------------------------------
display_cycle7 ; C1
;-------------------------------------------------------------------------------
;
    LedOutInd C1_A0_reg, Ax_dir, 0 ;   A0 Led 9G
    LedOutInd C1_A1_reg, Ax_dir, 1 ;   A1 Led 14G
    LedOutInd C1_A2_reg, Ax_dir, 2 ;   A2 Led 4G
    LedOutInd C1_C0_reg, Cx_dir, 0 ;   C0 Led 5G
    bsf                  Cx_dir, 2 ;   C2 no Led
    bsf                  Cx_dir, 3 ;   C3 no Led
    bsf                  Cx_dir, 4 ;   C4 Led 8R
    bsf                  Cx_dir, 5 ;   C5 Led 8R

    banksel TRISA
    movf    Ax_dir,w      ;set portA direction
    movwf   TRISA
    movf    Cx_dir,w      ;set portA direction
    movwf   TRISC

    banksel PORTA
    movlw   b'00000000'
    movwf   PORTA
    movlw   b'00000010'
    movwf   PORTC

    decfsz  fcount,f
    goto    display_cycle7

    goto return_display_cycle


;-------------------------------------------------------------------------------
display_cycle8 ; C2
;-------------------------------------------------------------------------------

    bsf                  Ax_dir, 0 ;   A0 18G
    bsf                  Ax_dir, 1 ;   A1 No led
    bsf                  Ax_dir, 2 ;   A2 15G
    bsf                  Cx_dir, 0 ;   C0 6G
    bsf                  Cx_dir, 1 ;   C1 No Led
    LedOutInd C2_C3_reg, Cx_dir, 3 ;   C3 No Led
    LedOutInd C2_C4_reg, Cx_dir, 4 ;   C4 No Led
    LedOutInd C2_C5_reg, Cx_dir, 5 ;   C5 No Led

    banksel TRISA
    movf    Ax_dir,w      ;set portA direction
    movwf   TRISA
    movf    Cx_dir,w      ;set portA direction
    movwf   TRISC

    banksel PORTA
    movlw   b'00000000'
    movwf   PORTA
    movlw   b'00000100'
    movwf   PORTC

    decfsz  fcount,f
    goto    display_cycle8

    goto return_display_cycle

;-------------------------------------------------------------------------------
display_cycle9 ; C2
;-------------------------------------------------------------------------------

    LedOutInd C2_A0_reg, Ax_dir, 0 ;   A0 18G
    bsf                  Ax_dir, 1 ;   A1 No led
    LedOutInd C2_A2_reg, Ax_dir, 2 ;   A2 15G
    LedOutInd C2_C0_reg, Cx_dir, 0 ;   C0 6G
    LedOutInd C2_C1_reg, Cx_dir, 1 ;   C1 No Led
    bsf                  Cx_dir, 3 ;   C3 No Led
    bsf                  Cx_dir, 4 ;   C4 No Led
    bsf                  Cx_dir, 5 ;   C5 No Led

    banksel TRISA
    movf    Ax_dir,w      ;set portA direction
    movwf   TRISA
    movf    Cx_dir,w      ;set portA direction
    movwf   TRISC

    banksel PORTA
    movlw   b'00000000'
    movwf   PORTA
    movlw   b'00000100'
    movwf   PORTC

    decfsz  fcount,f
    goto    display_cycle9

    goto return_display_cycle

;-------------------------------------------------------------------------------
display_cycle10 ; C3
;-------------------------------------------------------------------------------

    LedOutInd C3_A0_reg, Ax_dir, 0 ;   A0 18G
    LedOutInd C3_A1_reg, Ax_dir, 1 ;   A1 13G
    LedOutInd C3_A2_reg, Ax_dir, 2 ;   A2 15G
    LedOutInd C3_C0_reg, Cx_dir, 0 ;   C0 6G
    LedOutInd C3_C1_reg, Cx_dir, 1 ;   C1 No Led
    LedOutInd C3_C2_reg, Cx_dir, 2 ;   C2 No Led
    LedOutInd C3_C4_reg, Cx_dir, 4 ;   C4 No Led
    LedOutInd C3_C5_reg, Cx_dir, 5 ;   C5 No Led

    banksel TRISA
    movf    Ax_dir,w      ;set portA direction
    movwf   TRISA
    movf    Cx_dir,w      ;set portA direction
    movwf   TRISC

    banksel PORTA
    movlw   b'00000000'
    movwf   PORTA
    movlw   b'00001000'
    movwf   PORTC

    decfsz  fcount,f
    goto    display_cycle10

    goto return_display_cycle


;-------------------------------------------------------------------------------
display_cycle11 ; C4
;-------------------------------------------------------------------------------

    LedOutInd C4_A0_reg, Ax_dir, 0 ;   A0 Led 17G
    LedOutInd C4_A1_reg, Ax_dir, 1 ;   A1 Led 19G
    LedOutInd C4_A2_reg, Ax_dir, 2 ;   A2 Led 16G
    LedOutInd C4_C0_reg, Cx_dir, 0 ;   C0 Led 7G
    LedOutInd C4_C1_reg, Cx_dir, 1 ;   C1 Led 8G
    LedOutInd C4_C2_reg, Cx_dir, 2 ;   C2 No Led
    LedOutInd C4_C3_reg, Cx_dir, 3 ;   C3 No Led
    LedOutInd C4_C5_reg, Cx_dir, 5 ;   C5 No Led

    banksel TRISA
    movf    Ax_dir,w      ;set portA direction
    movwf   TRISA
    movf    Cx_dir,w      ;set portA direction
    movwf   TRISC

    banksel PORTA
    movlw   b'00000000'
    movwf   PORTA
    movlw   b'00010000'
    movwf   PORTC

    decfsz  fcount,f
    goto    display_cycle11

    goto return_display_cycle

;-------------------------------------------------------------------------------
display_cycle12 ; C5
;-------------------------------------------------------------------------------
;
    LedOutInd C5_A0_reg, Ax_dir, 0 ;   A0 Led 17G
    LedOutInd C5_A1_reg, Ax_dir, 1 ;   A1 Led 19G
    LedOutInd C5_A2_reg, Ax_dir, 2 ;   A2 Led 16G
    LedOutInd C5_C0_reg, Cx_dir, 0 ;   C0 Led 7G
    LedOutInd C5_C1_reg, Cx_dir, 1 ;   C1 Led 8G
    LedOutInd C5_C2_reg, Cx_dir, 2 ;   C2 No Led
    LedOutInd C5_C3_reg, Cx_dir, 3 ;   C3 No Led
    LedOutInd C5_C4_reg, Cx_dir, 4 ;   C4 No Led

    banksel TRISA
    movf    Ax_dir,w      ;set portA direction
    movwf   TRISA
    movf    Cx_dir,w      ;set portA direction
    movwf   TRISC

    banksel PORTA
    movlw   b'00000000'
    movwf   PORTA
    movlw   b'00100000'
    movwf   PORTC

    decfsz  fcount,f
    goto    display_cycle12

    goto return_display_cycle

